<?php
/**
 * Project:     PHPLinkDirectory: Link exchange directory
 *
 * License: GNU GPL (http://www.opensource.org/licenses/gpl-license.html)
 * 
 * This program is free software;
 * 
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * For questions, help, comments, discussion, etc., please join the
 * PHP Link Directory Forum http://www.phplinkdirectory.com/forum/

 *
 * @link http://www.phplinkdirectory.com/
 * @copyright 2004-2005 NetCreated, Inc. (http://www.netcreated.com/)
 * @projectManager David DuVal <david@david-duval.com>
 * @author Bogdan Dumitru <dcb@insomniacsoft.com>
 * @mod developers and support
 * 		Casey Wilson / Ap0s7le <at@ap0s7le.com>
 * 		York Kie Tan / yktan <yktan@hotmail.com>
 * @package PHPLinkDirectory
 * @version 2.0.0 RC5.2
 **/

require_once 'init.php';
$tpl->assign('ENABLE_REWRITE', ENABLE_REWRITE);
$tpl->assign('stats', array (0 => _L('Inactive'), 1 => _L('Pending'), 2 => _L('Active'),));
$tpl->assign('columns', array ('TITLE' => _L('Title'), 'URL' => _L('URL'), 'DESCRIPTION' => _L('Description'), 'CATEGORY' => _L('Category'), 'RECPR_URL' => _L('Recpr. Link URL'), 'DATE_ADDED' => _L('Date Added')));
if (defined('SORT_FIELD') && SORT_FIELD != '') {
	$orderBy = ' ORDER BY '. (SORT_FIELD == 'CATEGORY' ? 'C.TITLE' : 'L.'.SORT_FIELD).' '.SORT_ORDER;
}
if ($_SESSION['is_admin']) {
	$list_total = $db->GetOne("SELECT COUNT(*) FROM {$tables['link']['name']} WHERE STATUS = 1");
	$page = get_page($list_total);
	$tpl->assign('list_limit', LINKS_PER_PAGE);
	$tpl->assign('list_total', $list_total);
	$rs = $db->SelectLimit("SELECT L.*, ".$db->IfNull('C.TITLE', "'Top'")." AS CATEGORY FROM {$tables['link']['name']} AS L LEFT OUTER JOIN {$tables['category']['name']} AS C ON L.CATEGORY_ID = C.ID WHERE L.STATUS = 1 ".$orderBy, LINKS_PER_PAGE, LINKS_PER_PAGE * ($page -1));
	$list = $rs->GetAssoc(true);
} else {
	$list_total = $db->GetOne("SELECT COUNT(*) FROM {$tables['link']['name']} WHERE STATUS = 1 AND (".str_replace("ID","CATEGORY_ID",$_SESSION['user_permission']).")");
	$page = get_page($list_total);
	$tpl->assign('list_limit', LINKS_PER_PAGE);
	$tpl->assign('list_total', $list_total);
	$rs = $db->SelectLimit("SELECT L.*, ".$db->IfNull('C.TITLE', "'Top'")." AS CATEGORY FROM {$tables['link']['name']} AS L LEFT OUTER JOIN {$tables['category']['name']} AS C ON L.CATEGORY_ID = C.ID WHERE L.STATUS = 1 AND (".str_replace("ID","L.CATEGORY_ID",$_SESSION['user_permission']).") ".$orderBy, LINKS_PER_PAGE, LINKS_PER_PAGE * ($page -1));
	$list = $rs->GetAssoc(true);
}
$tpl->assign('list', $list);
$content = $tpl->fetch('admin/dir_approve_links.tpl');
$tpl->assign('content', $content);
echo $tpl->fetch('admin/main.tpl');
?>