<?php
/**
 * Project:     PHPLinkDirectory: Link exchange directory
 *
 * License: GNU GPL (http://www.opensource.org/licenses/gpl-license.html)
 * 
 * This program is free software;
 * 
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * For questions, help, comments, discussion, etc., please join the
 * PHP Link Directory Forum http://www.phplinkdirectory.com/forum/

 *
 * @link http://www.phplinkdirectory.com/
 * @copyright 2004-2005 NetCreated, Inc. (http://www.netcreated.com/)
 * @projectManager David DuVal <david@david-duval.com>
 * @author Bogdan Dumitru <dcb@insomniacsoft.com>
 * @mod developers and support
 * 		Casey Wilson / Ap0s7le <at@ap0s7le.com>
 * 		York Kie Tan / yktan <yktan@hotmail.com>
 * @package PHPLinkDirectory
 * @version 2.0.0 RC5.2
 **/

require_once 'init.php';
if (empty ($_REQUEST['submit']) && !empty ($_SERVER['HTTP_REFERER'])) {
	$_SESSION['return'] = $_SERVER['HTTP_REFERER'];
}
$tpl->assign('ENABLE_REWRITE', ENABLE_REWRITE);
if ($_REQUEST['action']) {
	list ($action, $id, $val) = split(':', $_REQUEST['action']);
}
$tpl->assign('stats', array (0 => _L('Inactive'), 1 => _L('Pending'), 2 => _L('Active'),));
switch ($action) {
	case 'S' : //Set Status
		$error = false;
		if(PAY_ENABLE && $val==2){
			$sql = "SELECT ID, PAYED, STATUS, EXPIRY_DATE FROM {$tables['link']['name']} WHERE ID='$id'";
			$data = $db->GetRow($sql);
			if($data['PAYED']>0){
				$sql = "SELECT ID, QUANTITY, UM FROM {$tables['payment']['name']} WHERE ID = ".$db->qstr($data['PAYED']);
				$pdata = $db->GetRow($sql);
				$exp_date = calculate_expiry_date(time(), $pdata['QUANTITY'], $pdata['UM']);
				if($exp_date!=0 && $data['EXPIRY_DATE'] == ''){
					$data['EXPIRY_DATE'] = gmdate('Y-m-d H:i:s', $exp_date);
				}
			}	
			$data['STATUS'] = 2;
			if(db_replace('link', $data, 'ID')>0){
				send_status_notifications($id);
			}else{
				$tpl->assign('sql_error', $db->ErrorMsg());
				$error = true;
			}		
		}else{
			if ($db->Execute("UPDATE {$tables['link']['name']} SET STATUS=".$db->qstr($val)." WHERE ID='$id'")) {
				send_status_notifications($id);
			} else {
				$tpl->assign('sql_error', $db->ErrorMsg());
				$error = true;
			}
		}
		if (!$error && isset ($_SESSION['return'])) {
					header("Location: ".$_SESSION['return']);
					exit;
		}
		break;	
	case 'A' :
		if ($db->Execute("UPDATE {$tables['link']['name']} SET STATUS=2 WHERE ID='$id'")) {
			send_status_notifications($id);
			if (isset ($_SESSION['return'])) {
				header("Location: ".$_SESSION['return']);
				exit;
			}
		} else {
			$tpl->assign('sql_error', $db->ErrorMsg());
		}
		break;
	case 'D' :
		$data = $db->GetRow("SELECT * FROM {$tables['link']['name']} WHERE ID = $id");
		if ($db->Execute("DELETE FROM {$tables['link']['name']} WHERE ID='$id'")) {
			$data['STATUS'] = 0;
			send_status_notifications($data, false);
			if (isset ($_SESSION['return'])) {
				header("Location: ".$_SESSION['return']);
				exit;
			}
		} else {
			$tpl->assign('sql_error', $db->ErrorMsg());
		}
		break;
	case 'E' :
		if (empty ($_REQUEST['submit'])) {
			$data = $db->GetRow("SELECT * FROM {$tables['link']['name']} WHERE ID='$id'");
		}
	case 'N' :
	default :
		if ($action == 'N') {
			$data['STATUS'] = 2;
			$data['RECPR_REQUIRED'] = REQUIRE_RECIPROCAL;
			if(FTR_ENABLE == 1){
				$data['FEATURED'] = $_REQUEST['f']=='1';
			}
		}
		$categs = get_categs_tree($db, 0);
		$tpl->assign('categs', $categs);
		if (empty ($_REQUEST['submit'])) {
			SmartyValidate :: connect($tpl);
			SmartyValidate :: register_form('dir_links_edit', true);
			SmartyValidate :: register_criteria('isValueUnique', 'validate_unique', 'dir_links_edit');
			SmartyValidate :: register_criteria('isNotEqual', 'validate_not_equal', 'dir_links_edit');
			SmartyValidate :: register_validator('v_TITLE', 'TITLE', 'notEmpty', false, false, false, 'trim', 'dir_links_edit');
			SmartyValidate :: register_validator('v_TITLE_U', "TITLE:link:$id:CATEGORY_ID", 'isValueUnique', false, false, false, null, 'dir_links_edit');
			SmartyValidate :: register_validator('v_URL', 'URL', 'isURL', false, false, false, 'trim', 'dir_links_edit');
			SmartyValidate :: register_validator('v_URL_U', 'URL:link:'.$id.(ALLOW_MULTIPLE?':CATEGORY_ID':''), 'isValueUnique', false, false, false, null, 'dir_links_edit');
			SmartyValidate :: register_validator('v_CATEGORY_ID', 'CATEGORY_ID:0', 'isNotEqual', true, false, false, null, 'dir_links_edit');
			SmartyValidate :: register_validator('v_RECPR_URL', 'RECPR_URL', 'isURL', true, false, false, 'trim', 'dir_links_edit');
			SmartyValidate :: register_validator('v_OWNER_EMAIL', 'OWNER_EMAIL', 'isEmail', true, false, false, 'trim', 'dir_links_edit');
			SmartyValidate :: register_validator('v_EXPIRY_DATE', 'EXPIRY_DATE', 'isDate', true, false, false, 'trim', 'dir_links_edit');
		} else {
			SmartyValidate :: connect($tpl);
			$data = get_table_data('link');
			if ($action == 'N') {
				$data['IPADDRESS'] = get_client_ip();
				$data['VALID'] = 1;
				$data['RECPR_VALID'] = 1;
				$data['DATE_ADDED'] = gmdate('Y-m-d H:i:s');
				$data['DATE_MODIFIED'] = gmdate('Y-m-d H:i:s');
			}
			if(FTR_ENABLE == 1){
				$data['FEATURED'] = $_REQUEST['FEATURED'] == '1'?'1':'0';
			}
			$data['NOFOLLOW'] = $_REQUEST['NOFOLLOW'] == '1'?'1':'0';
			$data['RECPR_REQUIRED'] = $_REQUEST['RECPR_REQUIRED'] == '1'?'1':'0';
			if (strlen(trim($data['URL'])) > 0 && !preg_match("`^http(s?)://`", $data['URL']))
				$data['URL'] = "http://".$data['URL'];
			if (strlen(trim($data['RECPR_URL'])) > 0 && !preg_match("`^http(s?)://`", $data['RECPR_URL']))
				$data['RECPR_URL'] = "http://".$data['RECPR_URL'];
			if(trim($data['EXPIRY_DATE'])==''){
				$data['EXPIRY_DATE'] = '';
			}else{
				if(strtotime($data['EXPIRY_DATE'])!=-1){
					$data['EXPIRY_DATE'] = date('Y-m-d H:i:s', (strtotime($data['EXPIRY_DATE'])));
				}
			}
			if (SmartyValidate :: is_valid($data, 'dir_links_edit')) {
				if (empty ($id)) {
					$id = $db->GenID($tables['link']['name'].'_SEQ');
				}
				if(ENABLE_PAGERANK){
					require_once 'include/pagerank.php';
					$data['PAGERANK'] = get_page_rank($data['URL']);
					if(!empty($data['RECPR_URL'])){
						$data['RECPR_PAGERANK'] = get_page_rank($data['RECPR_URL']);
					}
				}
				$data['ID'] = $id;
				if (!isset ($data['RECPR_REQUIRED'])) {
					$data['RECPR_REQUIRED'] = 0;
				}
				if (db_replace('link', $data, 'ID') > 0) {
					$tpl->assign('posted', true);
					if($action == 'N'){
						$cid = $data['CATEGORY_ID'];
						$data = array();
						$data['STATUS'] = 2;
						$data['CATEGORY_ID'] = $cid;
					}else{
						if (isset ($_SESSION['return'])) {
							header("Location: ".$_SESSION['return']);
							exit;
						}
					}
				} else {
					$tpl->assign('sql_error', $db->ErrorMsg());
				}
			}
		}
		$tpl->assign($data);
		$content = $tpl->fetch('admin/dir_links_edit.tpl');
		break;
}
$tpl->assign('content', $content);
echo $tpl->fetch('admin/main.tpl');

/**
 * Send submit/reject notifications
 * 
 * @param mixed $data if type is array it is considered a link associative array; otherwise it is considered a link id
 * 
 * @author dcb
 *
 */
function send_status_notifications($data, $update = true) {
	global $db, $tables;
	if(DEMO)
		return;
	if(is_array($data)){
		$id = $data['ID'];
	}else{
		$id = $data;
		$data = $db->GetRow("SELECT * FROM {$tables['link']['name']} WHERE ID = $id");
	}
	if($data['OWNER_NOTIF']>=2){
		return;
	}
	if($data['STATUS']==0){
		$tid = NTF_REJECT_TPL;
	}elseif($data['STATUS']==2){
		$tid = NTF_APPROVE_TPL;
	}else{
		return;
	}
	$sql = "SELECT SUBJECT, BODY FROM {$tables['email_tpl']['name']} WHERE ID=".$db->qstr($tid);
	$tmpl = $db->GetRow($sql);
	if ($tmpl) {
		$mail = get_emailer();
		$mail->Body = replace_email_vars($tmpl['BODY'], $data, 2);
		$mail->Subject = replace_email_vars($tmpl['SUBJECT'], $data, 2);
		if($data['OWNER_EMAIL']){
			$mail->AddAddress($data['OWNER_EMAIL'], $data['OWNER_NAME']);
			$sent = $mail->Send();
			if($update)
				$db->Execute("UPDATE {$tables['link']['name']} SET OWNER_NOTIF=2 WHERE ID='$id'");
		}
	}
}
?>