<?php
/**
 * Project:     PHPLinkDirectory: Link exchange directory
 *
 * License: GNU GPL (http://www.opensource.org/licenses/gpl-license.html)
 * 
 * This program is free software;
 * 
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * For questions, help, comments, discussion, etc., please join the
 * PHP Link Directory Forum http://www.phplinkdirectory.com/forum/

 *
 * @link http://www.phplinkdirectory.com/
 * @copyright 2004-2005 NetCreated, Inc. (http://www.netcreated.com/)
 * @projectManager David DuVal <david@david-duval.com>
 * @author Bogdan Dumitru <dcb@insomniacsoft.com>
 * @mod developers and support
 * 		Casey Wilson / Ap0s7le <at@ap0s7le.com>
 * 		York Kie Tan / yktan <yktan@hotmail.com>
 * @package PHPLinkDirectory
 * @version 2.0.0 RC5.2
 **/

require_once 'init.php';
require_once 'include/version.php';
$url = get_url("http://www.phplinkdirectory.com/current.php", URL_CONTENT, $_SERVER['SERVER_NAME'].request_uri());
$sv = parse_version($url['content']);
$cv = parse_version(CURRENT_VERSION);

if($sv>$cv){
	$version = _L("<b>A new version (##VERSION##) is available.</b>");
	$version = str_replace("##VERSION##", trim($url['content']), $version);
}else{
	$version = _L("Your installation is up to date, no updates are available for your version of phpLinkDirectory.");
}

$stats[0] = $db->GetOne("SELECT COUNT(*) FROM {$tables['link']['name']} WHERE STATUS > 1");
$stats[1] = $db->GetOne("SELECT COUNT(*) FROM {$tables['link']['name']} WHERE STATUS = 1");
$stats[2] = $db->GetOne("SELECT COUNT(*) FROM {$tables['link']['name']} WHERE STATUS = 0");
$stats[3] = $db->GetOne("SELECT COUNT(*) FROM {$tables['category']['name']}");
$stats[4] = $db->GetOne("SELECT COUNT(*) FROM {$tables['email']['name']}");
$stats[5] = $db->GetOne("SELECT COUNT(*) FROM {$tables['email_tpl']['name']}");

if(ENABLE_NEWS){
	$url = get_url("http://www.phplinkdirectory.com/news.php", URL_CONTENT);
	if($url['status']){
		$news = parse_news($url['content']);
		$tpl->assign('news', $news);
	}
}

$tpl->assign('stats', $stats);
$tpl->assign('version', $version);


$content = $tpl->fetch('admin/index.tpl');
$tpl->assign('content', $content);

echo $tpl->fetch('admin/main.tpl');
?>