<?php
/**
 * Project:     PHPLinkDirectory: Link exchange directory
 *
 * License: GNU GPL (http://www.opensource.org/licenses/gpl-license.html)
 * 
 * This program is free software;
 * 
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * For questions, help, comments, discussion, etc., please join the
 * PHP Link Directory Forum http://www.phplinkdirectory.com/forum/

 *
 * @link http://www.phplinkdirectory.com/
 * @copyright 2004-2005 NetCreated, Inc. (http://www.netcreated.com/)
 * @projectManager David DuVal <david@david-duval.com>
 * @author Bogdan Dumitru <dcb@insomniacsoft.com>
 * @mod developers and support
 * 		Casey Wilson / Ap0s7le <at@ap0s7le.com>
 * 		York Kie Tan / yktan <yktan@hotmail.com>
 * @package PHPLinkDirectory
 * @version 2.0.0 RC5.2
 **/

require_once 'init.php';
session_start();

if($_REQUEST['id']){
	$id = $_REQUEST['id'];
	$action = 'pay';
}elseif($_REQUEST['payed']){
	$id = $_REQUEST['payed'];
	$action = 'payed';
}elseif($_REQUEST['canceled']){
	$id = $_REQUEST['canceled'];
	$action = 'canceled';
}
if(preg_match('`\d+`', $id)){
	$data = $db->GetRow("SELECT * FROM {$tables['link']['name']} WHERE ID = ".$db->qstr($id));
}
if (empty($data['ID'])) {
	echo $tpl->fetch('payment.tpl');
	exit;
}

$price = array ();
if (FTR_ENABLE == '1' && PAY_FEATURED > 0) {
	$price[$link_type_int['featured']] = PAY_FEATURED;
}
if (PAY_NORMAL > 0) {
	$price[$link_type_int['normal']] = PAY_NORMAL;
	if (PAY_ENABLE_FREE) {
		$price[$link_type_int['free']] = 0;
	}
}
if (PAY_RECPR > 0) {
	$price[$link_type_int['reciprocal']] = PAY_RECPR;
}

if($action=='pay'){
	if (empty ($_REQUEST['submit'])) {
		if (!empty ($_SERVER['HTTP_REFERER']))
			$_SESSION['return'] = $_SERVER['HTTP_REFERER'];
		SmartyValidate :: connect($tpl);
		SmartyValidate :: register_form('pay_link', true);
		SmartyValidate :: register_validator('v_quantity', 'quantity', 'isInt', false, false, false, 'trim', 'pay_link');
	}else{
		SmartyValidate :: connect($tpl);
		if (SmartyValidate :: is_valid($_REQUEST, 'pay_link')) {
			$pay_data = array();
			$pay_id = $db->GenID($tables['payment']['name'].'_SEQ');
			$pay_data['ID'] = $pay_id;
			$pay_data['LINK_ID'] = $data['ID'];
			$pay_data['IPADDRESS'] = get_client_ip();
			$pay_data['QUANTITY'] = $_REQUEST['quantity'];
			$pay_data['AMOUNT'] = $price[$data['LINK_TYPE']];
			$pay_data['TOTAL'] = (int)$pay_data['QUANTITY'] * (float)$pay_data['AMOUNT'];
			$pay_data['UM'] = PAY_UM;
			$pay_data['PAY_DATE'] = gmdate('Y-m-d H:i:s');
			$pay_data['CONFIRMED'] = -1;
			if(db_replace('payment', $pay_data, 'ID') > 0){
				$action = 'paypal';
				$tpl->assign('PAYMENT', $pay_data);
			}else{
				$tpl->assign('error', true);
			}
		}
	}
	$quantity = $_REQUEST['quantity']?$_REQUEST['quantity']:1;
		
}

$tpl->assign('quantity', $quantity);
$tpl->assign('price', $price);
$tpl->assign('action', $action);
$path = array ();
$path[] = array ('ID' => '0', 'TITLE' => _L(SITE_NAME), 'TITLE_URL' => DOC_ROOT, 'DESCRIPTION' => SITE_DESC);
$path[] = array ('ID' => '0', 'TITLE' => _L('Link Payment'), 'TITLE_URL' => '', 'DESCRIPTION' => _L('Submit a new link to the directory '));
$tpl->assign('path', $path);
$tpl->assign($data);
$tpl->assign('payment_um', $payment_um);
if($action == 'paypal'){
	echo $tpl->fetch('paypal.tpl');
}else{
	echo $tpl->fetch('payment.tpl');
}
?>